## flightcrew 0.9.3+dfsg

=== CMakeLists.txt ===
########################################################
#  
#  This is a CMake configuration file.
#  To use it you need CMake which can be 
#  downloaded from here: 
#    http://www.cmake.org/cmake/resources/software.html
#
#########################################################

cmake_minimum_required( VERSION 2.8 ) 

project( FlightCrew )

set( CMAKE_DEBUG_POSTFIX "d" )
set( CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin )
set( CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib )
set( PACKAGE_DIRECTORY ${PROJECT_BINARY_DIR}/package )

set( FLIGHTCREW_MAJOR_VERSION 0 )
set( FLIGHTCREW_MINOR_VERSION 9 )
set( FLIGHTCREW_REVISION_VERSION 3 )
set( FLIGHTCREW_FULL_VERSION ${FLIGHTCREW_MAJOR_VERSION}.${FLIGHTCREW_MINOR_VERSION}.${FLIGHTCREW_REVISION_VERSION} )

# Check if platform is 64 bit
if( NOT APPLE )
   if( CMAKE_SIZEOF_VOID_P EQUAL 4 )
     set( 64_BIT_PLATFORM 0 )
   else()
     set( 64_BIT_PLATFORM 1 )
   endif()
endif()

# We need this to make sure g++ and the linker
# create exes that can run on 10.9+
set( CMAKE_OSX_DEPLOYMENT_TARGET "10.9" )

# 10.9 is the required minimum OS X version.
# set( CMAKE_OSX_SYSROOT "/Developer/SDKs/MacOSX10.9.sdk" )
# Universal builds for mac
# set( CMAKE_OSX_ARCHITECTURES "i386;x86_64" )


# The parsing order is significant!

add_subdirectory( src/BoostParts )
# Set these so zipios doesn't complain.
set( Boost_DATE_TIME_LIBRARY 1 )
set( Boost_FILESYSTEM_LIBRARY 1 )
set( Boost_PROGRAM_OPTIONS_LIBRARY 1 )
set( Boost_REGEX_LIBRARY 1 )
set( Boost_SYSTEM_LIBRARY 1 )
set( Boost_THREAD_LIBRARY 1 )
set( BOOST_LIBS BoostParts )
set( BOOST_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/src/BoostParts )

add_subdirectory( src/Xerces )
set( XERCES_LIBRARIES Xerces )
set( XERCES_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/src/Xerces )

add_subdirectory( src/XercesExtensions )
set( XERCESEXTENSIONS_LIBRARIES XercesExtensions )
set( XERCESEXTENSIONS_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/src/XercesExtensions )

add_subdirectory( src/zlib )
add_subdirectory( src/zipios )
if( NOT MINGW )
    add_subdirectory( src/googlemock )
endif()

add_subdirectory( src/FlightCrew )
set( FLIGHTCREW_LIBRARIES FlightCrew )
set( FLIGHTCREW_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/src/FlightCrew )

add_subdirectory( src/FlightCrew-cli )

if( NOT SKIP_FC_GUI )
    add_subdirectory( src/FlightCrew-gui )
endif()

if( NOT SKIP_FC_PLUGIN )
    add_subdirectory( src/FlightCrew-plugin )
endif()

=== src/FlightCrew/CMakeLists.txt ===
########################################################
#  
#  This is a CMake configuration file.
#  To use it you need CMake which can be 
#  downloaded from here: 
#    http://www.cmake.org/cmake/resources/software.html
#
#########################################################

cmake_minimum_required( VERSION 2.8 )

# Print a message and fail for people who don't
# read the build instructions and then complain
# when the build process fails for them.
if ( ${CMAKE_CURRENT_SOURCE_DIR} STREQUAL ${CMAKE_SOURCE_DIR} )
    message( FATAL_ERROR "You are trying to run CMake from the <top_folder>/src/FlightCrew directory, "
                         "instead of just from the <top_folder> directory.\nDO NOT DO THIS.\n"
                         "The correct way looks like this:\n"
                         "  cmake -G '<generator_name>' /path/to/topmost/folder/in/source/package\n"
                         "You will probably now need to first clean your build directory." )
endif() 

#############################################################################

project( FlightCrew )

file( GLOB_RECURSE SOURCES *.h *.cpp *.xsd *.dtd )

# The test sources are a part of a different target, so we remove them
file( GLOB_RECURSE to_remove tests/*.h tests/*.cpp )
if( to_remove )
    list( REMOVE_ITEM SOURCES ${to_remove} )
endif() 

#############################################################################

# Creating source groups for VS, Xcode
include( ${CMAKE_SOURCE_DIR}/cmake_extras/FileSystemSourceGroups.cmake )
create_source_groups( SOURCES )

#############################################################################

set( PCH_NAME stdafx )

# stdafx.cpp is compiled separately as a PCH
if( NOT SKIP_PCH )
    file( GLOB to_remove ${PCH_NAME}.cpp )
    list( REMOVE_ITEM SOURCES ${to_remove} )
endif()

#############################################################################

# creating PCH's for MSVC and GCC on Linux
include( ${CMAKE_SOURCE_DIR}/cmake_extras/CustomPCH.cmake )
set( ALL_INCLUDES ${BoostParts_SOURCE_DIR}
                  ${Xerces_SOURCE_DIR}
                  ${zipios_SOURCE_DIR} )
set( GCC_PCH_TARGET gccPCH_fc )

if( NOT SKIP_PCH )
    precompiled_header( SOURCES ALL_INCLUDES ${GCC_PCH_TARGET} ${PCH_NAME} )
endif()

#############################################################################

# We need to pick up the stdafx.h file (current source dir),
# and the headers for the linked-to libraries
include_directories( ${CMAKE_CURRENT_SOURCE_DIR}
                     ../zipios
                     ../BoostParts 
                     ../Xerces
                     ../XercesExtensions
                     ../utf8-cpp
                   )

# and pick up the stdafx.h.gch file (current binary dir) if generating PCHs
if( NOT SKIP_PCH )
    list( INSERT include_directories 0 ${CMAKE_CURRENT_BINARY_DIR} )
endif()

link_directories ( ${PROJECT_BINARY_DIR}/lib ) 

if( BUILD_SHARED_FC )
    # Windows clients also need to specify FC_BUILT_AS_DLL
    # when they want a dll, but NOT FC_DLL_EXPORTING
    add_definitions( -DFC_DLL_EXPORTING -DFC_BUILT_AS_DLL )
    add_library( ${PROJECT_NAME} SHARED ${SOURCES} )
else()
    add_library( ${PROJECT_NAME} STATIC ${SOURCES} )
endif()

target_link_libraries( ${PROJECT_NAME} zipios BoostParts XercesExtensions )

#############################################################################

if( NOT SKIP_PCH )
    # Xcode PCH support. Has to come after the target is created.              
    xcode_pch( ${PCH_NAME} )
endif()

#############################################################################

# "Link time code generation" flags for MSVC
# TODO: split into special cmake file
if( MSVC )
    add_definitions( /DUNICODE /D_UNICODE /W4 )
    
    # This warning is present only at the highest warning level (/W4)
    # and is routinely disabled because it complains about valid 
    # constructs like "while (true)"
    add_definitions( /wd4127 )
    
    # The /Zc:wchar_t- flag can't go into add_definitions
    # because the RC compiler picks it up too and it provokes a name clash
    set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Zc:wchar_t- /MP")
    set( CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /Oi /GL" ) 
    set( CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /LTCG" )

elseif( CMAKE_COMPILER_IS_GNUCXX )
    # "Print all warnings" flag for GCC
    add_definitions( -Wall )

	if( NOT SKIP_PCH )
        # Make sure the PCH is built for GCC
        add_dependencies( ${PROJECT_NAME} ${GCC_PCH_TARGET} )
	endif()
endif()

# needed for correct Xerces header inclusion
add_definitions( -DXERCES_STATIC_LIBRARY )

#############################################################################

# We don't build the tests when fc is built as a shared
# library on msvc since the tests need access to the fc
# internal apis which are not exported when building a DLL.
# If we tried to build them, we would get linker errors.
# We also don't build the tests if the user specified it.
if( NOT ( BUILD_SHARED_FC AND MSVC ) AND NOT NO_TEST_EXE )
    add_subdirectory( tests )
endif()

=== src/XercesExtensions/CMakeLists.txt ===
########################################################
#  
#  This is a CMake configuration file.
#  To use it you need CMake which can be 
#  downloaded from here: 
#    http://www.cmake.org/cmake/resources/software.html
#
#########################################################

cmake_minimum_required( VERSION 2.8 ) 

project( XercesExtensions )

file( GLOB SOURCES *.cpp *.h ) 

# We need to pick up the stdafx.h file
# and the headers for the linked-to libraries
include_directories( ${CMAKE_CURRENT_SOURCE_DIR}
                     ${XERCES_INCLUDE_DIRS}
                     ${BOOST_INCLUDE_DIRS} )

link_directories ( ${PROJECT_BINARY_DIR}/lib ) 

add_library( ${PROJECT_NAME} STATIC ${SOURCES} )

target_link_libraries( ${PROJECT_NAME} ${XERCES_LIBRARIES} )

#############################################################################

# "Link time code generation" flags for MSVC
# TODO: split into special cmake file
if( MSVC )
    add_definitions( /DUNICODE /D_UNICODE /W4 )
    
    # This warning is present only at the highest warning level (/W4)
    # and is routinely disabled because it complains about valid 
    # constructs like "while (true)"
    add_definitions( /wd4127 )
    
    # The /Zc:wchar_t- flag can't go into add_definitions
    # because the RC compiler picks it up too and it provokes a name clash
    set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Zc:wchar_t- /MP")
    set( CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /Oi /GL" ) 
    set_target_properties( ${PROJECT_NAME} PROPERTIES STATIC_LIBRARY_FLAGS "/LTCG" )

# "Print all warnings" flag for GCC
elseif( CMAKE_COMPILER_IS_GNUCXX )
    add_definitions( -Wall )
endif()

# needed for correct Xerces header inclusion
if( FORCE_BUNDLED_COPIES OR NOT XERCES_FOUND)
    add_definitions( -DXERCES_STATIC_LIBRARY )
endif()

=== src/zipios/CMakeLists.txt ===
########################################################
#  
#  This is a CMake configuration file.
#  To use it you need CMake which can be 
#  downloaded from here: 
#    http://www.cmake.org/cmake/resources/software.html
#
#########################################################

cmake_minimum_required( VERSION 2.8 ) 

project( zipios )

file( GLOB_RECURSE SOURCES *.cpp *.h ) 

# We need to pick up the stdafx.h file
# and the headers for the linked-to libraries
include_directories( ${CMAKE_CURRENT_SOURCE_DIR}
                     ${BoostParts_SOURCE_DIR}
                     ${zlib_SOURCE_DIR}
                     ${zlib_BINARY_DIR}
                     )

link_directories ( ${PROJECT_BINARY_DIR}/lib )

add_library( ${PROJECT_NAME} STATIC ${SOURCES} )

target_link_libraries( ${PROJECT_NAME} zlib BoostParts )

#############################################################################

# "Link time code generation" flags for MSVC
# TODO: split into special cmake file
if( MSVC )
    add_definitions( /DUNICODE /D_UNICODE /D_CRT_SECURE_NO_DEPRECATE )
    
    # This warning is present only at the highest warning level (/W4)
    # and is routinely disabled because it complains about valid 
    # constructs like "while (true)"
    add_definitions( /wd4127 )
    set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Zc:wchar_t-" )
    set( CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /Oi /GL" ) 
    set_target_properties( ${PROJECT_NAME} PROPERTIES STATIC_LIBRARY_FLAGS "/LTCG" )

# "Print all warnings" flag for GCC
elseif( CMAKE_COMPILER_IS_GNUCXX )
    add_definitions( -Wall )
endif()

=== debian/changelog ===
flightcrew (0.9.3+dfsg-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062593

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Wed, 28 Feb 2024 08:43:02 +0000

flightcrew (0.9.3+dfsg-2) unstable; urgency=medium

  [ Francois Mazen ]
  * Fix FTBS with Boost 1.83 (Closes: #1056080)
  * Update missing-sources with some xhtml data
  * Bump standard version to 4.6.2
  * Flag patch forwarding as not-needed because upstream code have been archived

  [ Mattia Rizzolo ]
  * Build with -D_FORTIFY_SOURCE=2
  * Bump debhelper compat level to 13
  * Drop explicit dh_missing --fail-missing

 -- Francois Mazen <mzf@debian.org>  Wed, 20 Dec 2023 21:01:55 +0100

=== debian/control ===
Source: flightcrew
Section: text
Priority: optional
Maintainer: Francois Mazen <mzf@debian.org>
Uploaders: Mattia Rizzolo <mattia@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5),
 cmake,
 debhelper-compat (= 13),
 googletest,
 libboost-date-time-dev,
 libboost-filesystem-dev,
 libboost-program-options-dev,
 libboost-regex-dev,
 libboost-system-dev,
 libboost-thread-dev,
 qtbase5-dev,
 libxerces-c-dev,
 pkg-kde-tools,
 zlib1g-dev,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://github.com/Sigil-Ebook/flightcrew
Vcs-Git: https://salsa.debian.org/debian/flightcrew.git
Vcs-Browser: https://salsa.debian.org/debian/flightcrew

Package: flightcrew
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 epub-utils,
 sigil,
Description: C++ epub validator
 FlightCrew is an epub validator written in C++. It is used by sigil
 to validate epub files, and may be generally useful for other epub
 creation utilities.

Package: libflightcrew0t64
Provides: ${t64:Provides}
X-Time64-Compat: libflightcrew0v5
Breaks: libflightcrew0v5 (<< ${source:Version})
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts:
 libflightcrew0,
Replaces:libflightcrew0v5, 
 libflightcrew0,
Description: C++ library for epub validation
 FlightCrew is an epub validator written in C++. It is used by sigil
 to validate epub files, and may be generally useful for other epub
 creation utilities.
 .
 This package contains the shared library.

Package: libflightcrew-dev
Architecture: all
Section: libdevel
Depends:
 libflightcrew0t64 (<< ${source:Version}.1~),
 libflightcrew0t64 (>= ${source:Version}),
 libboost-exception-dev,
 ${misc:Depends},
Description: C++ library development filesfor epub validation
 FlightCrew is an epub validator written in C++. It is used by sigil
 to validate epub files, and may be generally useful for other epub
 creation utilities.
 .
 This package contains the development headers.

=== debian/tests/control ===
Tests: flightcrew-cli-test
Depends: flightcrew, expect

Test-Command: xvfb-run ./debian/tests/flightcrew-gui-test
Depends: flightcrew, xvfb, xauth, xdotool
Restrictions: allow-stderr

Tests: flightcrew-dev-test
Depends: libflightcrew-dev, build-essential

Tests: CVE-2019-13032 CVE-2019-13241
Depends: flightcrew

=== debian/watch ===
version=4
opts=\
dversionmangle=s/\+(debian|dfsg|ds|deb)(\d+)?$//,\
repacksuffix=+dfsg,\
filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/flightcrew-$1\.tar\.gz/ \
  https://github.com/Sigil-Ebook/flightcrew/tags .*/v?(\d\S+)\.tar\.gz
